# generated by datamodel-codegen:
#   filename:  klighd/SKGraphSchema.json
#   timestamp: 2025-04-16T13:00:53+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional

from pydantic import BaseModel, Field


class SModelElement(BaseModel):
    type: str
    id: str
    children: Optional[List[SModelElement]] = []
    trace: Optional[str] = None


class Size(BaseModel):
    width: Optional[float] = None
    height: Optional[float] = None


class Position(BaseModel):
    x: Optional[float] = None
    y: Optional[float] = None


class SShapeElement(SModelElement):
    size: Optional[Size] = Field(
        default_factory=lambda: Size.parse_obj({'width': 0.0, 'height': 0.0})
    )
    position: Optional[Position] = Field(
        default_factory=lambda: Position.parse_obj({'x': 0.0, 'y': 0.0})
    )


class JunctionPoint(BaseModel):
    x: Optional[float] = None
    y: Optional[float] = None


class KGraphData(BaseModel):
    properties: Optional[Dict[str, Any]] = {}


class KPlacementData(BaseModel):
    stub: Optional[str] = None


class SKElement(BaseModel):
    data: Optional[List[KGraphData]] = []
    properties: Optional[Dict[str, Any]] = {}
    type: str


class SKGraph(SKElement, SModelElement):
    type: Optional[str] = 'graph'
    revision: float
    children: Optional[List[SModelElement]] = Field([], max_items=1, min_items=1)


class SKNode(SKElement, SShapeElement):
    type: Optional[str] = 'node'


class SKLabel(SKElement, SModelElement):
    text: str
    type: Optional[str] = 'label'


class SKEdge(SKElement, SModelElement):
    sourceId: str
    targetId: str
    junctionPoints: Optional[List[JunctionPoint]] = []
    type: Optional[str] = 'edge'


class SKPort(SKElement, SShapeElement):
    type: Optional[str] = 'port'


class KRendering(KGraphData):
    placementData: Optional[KPlacementData] = None
    styles: Optional[List] = []
    actions: Optional[List] = []
    type: Optional[str] = 'KRenderingImpl'


class KContainerRendering(KRendering):
    children: Optional[List[KRendering]] = []
    childPlacement: Optional[Any] = None
    type: Optional[str] = 'KContainerRenderingImpl'


class KRectangle(KContainerRendering):
    type: Optional[str] = 'KRectangleImpl'


class KRoundedRectangle(KRectangle):
    cornerWidth: Optional[float] = None
    cornerHeight: Optional[float] = None
    type: Optional[str] = 'KRoundedRectangleImpl'


class KPolyline(KContainerRendering):
    type: Optional[str] = 'KPolylineImpl'
    junctionPointRendering: Optional[KRendering] = None


class KPolygon(KPolyline):
    type: Optional[str] = 'KPolygonImpl'


class KSpline(KPolyline):
    type: Optional[str] = 'KSplineImpl'


class KImage(KContainerRendering):
    bundleName: Optional[str] = None
    imagePath: Optional[str] = None
    type: Optional[str] = 'KImageImpl'


class KEllipse(KContainerRendering):
    type: Optional[str] = 'KEllipseImpl'


class KArc(KContainerRendering):
    startAngle: Optional[float] = None
    arcAngle: Optional[float] = None
    type: Optional[str] = 'KArcImpl'


class KText(KContainerRendering):
    text: Optional[str] = None
    clip: Optional[bool] = None
    type: Optional[str] = 'KTextImpl'


SModelElement.update_forward_refs()
