# generated by datamodel-codegen:
#   filename:  klighd/SynthesisOptionSchema.json
#   timestamp: 2025-04-16T13:00:53+00:00

from __future__ import annotations

from enum import Enum
from typing import Any, List, Optional, Union

from pydantic import BaseModel


class SynthesisOptionSchema(BaseModel):
    pass


class Type(Enum):
    number_0 = 0
    number_1 = 1
    number_2 = 2
    number_3 = 3
    number_4 = 4
    number_5 = 5


class Type1(Enum):
    number_0 = 0


class Type2(Enum):
    number_1 = 1


class Type3(Enum):
    number_2 = 2


class Range(BaseModel):
    first: Optional[float] = None
    second: Optional[float] = None


class Type4(Enum):
    number_3 = 3


class Type5(Enum):
    number_4 = 4


class Type6(Enum):
    number_5 = 5


class ValuedSynthesisOption(BaseModel):
    synthesisOption: Union[
        CheckSynthesisOption,
        ChoiceSynthesisOption,
        RangeSynthesisOption,
        TextSynthesisOption,
        SeparatorSynthesisOption,
        CategorySynthesisOption,
    ]
    currentValue: Union[str, float, bool]


class SynthesisOption(BaseModel):
    id: str
    name: str
    type: Type
    updateAction: Optional[str] = None
    category: Optional[CategorySynthesisOption] = None
    sourceHash: str
    initialValue: Any


class CheckSynthesisOption(SynthesisOption):
    type: Optional[Type1] = 0
    initialValue: Optional[bool] = None


class ChoiceSynthesisOption(SynthesisOption):
    type: Optional[Type2] = 1
    initialValue: Optional[str] = None
    values: List[str]


class RangeSynthesisOption(SynthesisOption):
    type: Optional[Type3] = 2
    initialValue: Optional[float] = None
    range: Range
    stepSize: float


class TextSynthesisOption(SynthesisOption):
    type: Optional[Type4] = 3
    initialValue: Optional[str] = None


class SeparatorSynthesisOption(SynthesisOption):
    type: Optional[Type5] = 4


class CategorySynthesisOption(SynthesisOption):
    type: Optional[Type6] = 5
    initialValue: Optional[bool] = None


ValuedSynthesisOption.update_forward_refs()
SynthesisOption.update_forward_refs()
CheckSynthesisOption.update_forward_refs()
ChoiceSynthesisOption.update_forward_refs()
RangeSynthesisOption.update_forward_refs()
TextSynthesisOption.update_forward_refs()
SeparatorSynthesisOption.update_forward_refs()
CategorySynthesisOption.update_forward_refs()
